{% extends "base.html" %}
{% load i18n %}
{% load crispy_forms_tags %}

{% block title %}{% trans 'Vote' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row no-gutters card-row">
        <div class="col-12 col-sm-9 col-lg-6 mx-auto my-auto">
            <div class="card">
                <div class="card-header">
                    <h1 class="text-center">{{ votation.topic }}</h1>
                </div>
                <div class="card-body">
                    {% if votation_closed %}
                    <span class="badge badge-danger"><i class="fas fa-times"></i> Closed</span>
                    {% else %}
                    <span class="badge badge-success"><i class="fas fa-check"></i> Open</span>
                    {% endif %}
                    <hr>
                    <h5><strong>Description - </strong>{{ votation.description }}</h5>
                    <h5><strong>Expires - </strong>{{ votation.end_date }}</h5>
                    <h6>Drag Choices: Top is your first choice</h6>
                    <br>
                    <form id="vote" method="post" action="{% url 'votations:voterank' pk=votation.pk %}">
                        {% csrf_token %}
                        <ol id="simpleList" class="list-group">
                            {% for choice in votation.votationchoice_set.all %}
                            <input type="hidden" name='result-{{ forloop.counter0 }}' value="" />
                            <li class="list-group-item" value="{{ choice.pk }}">{{ choice.name }}</li>
                            {% endfor %}
                        </ol>
                        <br>
                        <div class="d-flex justify-content-between" style="flex-wrap: wrap;">
                            <div>
                                <a class="btn btn-secondary {% if not request.GET.next %}disabled{% endif %}" href="{{ request.GET.next }}">
                                    <i class="fas fa-arrow-left"></i>
                                </a>
                            </div>
                            <div>
                                {% block extra_form_buttons %}{% endblock extra_form_buttons %}
                                <button type="submit" class="btn btn-primary">
                                    <i class="fas fa-check fa-fw mr-1"></i>{% trans "Submit" %}
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">

    var map = {};
    {% for choice in votation.votationchoice_set.all %}
    map["{{ choice.name }}"] = {{ choice.pk }};
    {% endfor %}

    $('#vote').submit(function () { //listen for submit event
        // Pull the ordered list and add the PK to our hidden results in order
        $("ol li").each(function (index) {
            input_name = "result-" + index;
            result = map[$(this).text()];
            $('input[name="' + input_name + '"]').val(result);
        });
        return true;
    });

    new Sortable(simpleList, {
        animation: 150,
        ghostClass: 'blue-background-class'
    });
</script>
<style>
    /* The container */
    .container {
        position: relative;
        padding-left: 35px;
        margin-bottom: 18px;
        cursor: pointer;
        font-size: 22px;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
    }

    /* Hide the browser's default radio button */
    .container input {
        position: absolute;
        opacity: 0;
        cursor: pointer;
    }

    /* Create a custom radio button */
    .checkmark {
        position: absolute;
        top: 0;
        left: 0;
        height: 25px;
        width: 25px;
        background-color: #dbdbdb;
        border-radius: 50%;
    }

    /* On mouse-over, add a grey background color */
    .container:hover input~.checkmark {
        background-color: #848587;
    }

    /* When the radio button is checked, add a blue background */
    .container input:checked~.checkmark {
        background-color: #2196F3;
    }

    /* Create the indicator (the dot/circle - hidden when not checked) */
    .checkmark:after {
        content: "";
        position: absolute;
        display: none;
    }

    /* Show the indicator (dot/circle) when checked */
    .container input:checked~.checkmark:after {
        display: block;
    }

    /* Style the indicator (dot/circle) */
    .container .checkmark:after {
        top: 9px;
        left: 9px;
        width: 8px;
        height: 8px;
        border-radius: 50%;
        background: white;
    }

    .badge {
        font-size: 14px;
    }
</style>
{% endblock %}